var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "../system_lib/Feed", "../system/SimpleHTTP", "../system_lib/Metadata"], function (require, exports, feed, SimpleHTTP_1, Metadata_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.VisitorsToday = void 0;
    var VisitorsToday = (function (_super) {
        __extends(VisitorsToday, _super);
        function VisitorsToday(env) {
            var _this = _super.call(this, env) || this;
            _this.establishFeed(new Collection("Visitors"));
            return _this;
        }
        return VisitorsToday;
    }(feed.Feed));
    exports.VisitorsToday = VisitorsToday;
    var kSpreadsheetURL = "https://docs.google.com/spreadsheets/d/e/2PACX-1vQVE3v1sikxm1esuNdlW-erWrtA_GemjtKVJtmd0fpXQmux7AS8_7yFgewLKj99IY0NS5qz88NgJ8go/pub?gid=0&single=true&output=csv";
    var Collection = (function () {
        function Collection(feedName) {
            this.listType = Item;
            this.itemType = Item;
            this.name = feedName;
        }
        Collection.prototype.getList = function (spec) {
            var _this = this;
            return SimpleHTTP_1.SimpleHTTP.newRequest(kSpreadsheetURL, { interpretResponse: true }).get().then(function (response) {
                var result = {
                    items: []
                };
                for (var _i = 0, _a = response.interpreted; _i < _a.length; _i++) {
                    var csv = _a[_i];
                    result.items.push(new Item(csv));
                }
                _this.lastItems = result.items;
                return result;
            });
        };
        Collection.prototype.getDetails = function (spec) {
            return Promise.resolve(this.lastItems[spec.index]);
        };
        return Collection;
    }());
    var Item = (function () {
        function Item(csv) {
            this.salutation = csv.Title;
            this.givenName = csv['Given Name'];
            this.surName = csv.Surname;
            this.city = csv.City;
            this.coutry = csv.Country;
            this.company = csv.Company;
        }
        __decorate([
            Metadata_1.field("Mr, Ms, Dr, etc"),
            __metadata("design:type", String)
        ], Item.prototype, "salutation", void 0);
        __decorate([
            Metadata_1.field("First name"),
            __metadata("design:type", String)
        ], Item.prototype, "givenName", void 0);
        __decorate([
            Metadata_1.field("Last name"),
            __metadata("design:type", String)
        ], Item.prototype, "surName", void 0);
        __decorate([
            Metadata_1.field(),
            __metadata("design:type", String)
        ], Item.prototype, "city", void 0);
        __decorate([
            Metadata_1.field(),
            __metadata("design:type", String)
        ], Item.prototype, "coutry", void 0);
        __decorate([
            Metadata_1.field(),
            __metadata("design:type", String)
        ], Item.prototype, "company", void 0);
        return Item;
    }());
});
